Index: palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_u.f90	(revision 4670)
+++ palm/trunk/SOURCE/diffusion_u.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4583 2020-06-29 12:36:47Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -247,23 +250,45 @@
 !
 !--             Natural-type surfaces, upward-facing
-                surf_s = surf_lsm_h%start_index(j,i)
-                surf_e = surf_lsm_h%end_index(j,i)
-                DO  m = surf_s, surf_e
-
-                   k   = surf_lsm_h%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_lsm_h%usws(m) ) ) * ddzw(k) * drho_air(k)
+                surf_s = surf_lsm_h(0)%start_index(j,i)
+                surf_e = surf_lsm_h(0)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_lsm_h(0)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - ( - surf_lsm_h(0)%usws(m) ) ) * ddzw(k) * drho_air(k)
+                ENDDO
+!
+!--             Natural-type surfaces, downward-facing
+                surf_s = surf_lsm_h(1)%start_index(j,i)
+                surf_e = surf_lsm_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_lsm_h(1)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - surf_lsm_h(1)%usws(m) ) * ddzw(k) * drho_air(k)
                 ENDDO
 !
 !--             Urban-type surfaces, upward-facing
-                surf_s = surf_usm_h%start_index(j,i)
-                surf_e = surf_usm_h%end_index(j,i)
-                DO  m = surf_s, surf_e
-
-                   k   = surf_usm_h%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_usm_h%usws(m) ) ) * ddzw(k) * drho_air(k)
+                surf_s = surf_usm_h(0)%start_index(j,i)
+                surf_e = surf_usm_h(0)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_usm_h(0)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - ( - surf_usm_h(0)%usws(m) ) ) * ddzw(k) * drho_air(k)
+                ENDDO
+!
+!--             Urban-type surfaces, downward-facing
+                surf_s = surf_usm_h(1)%start_index(j,i)
+                surf_e = surf_usm_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_usm_h(1)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - surf_usm_h(1)%usws(m) ) * ddzw(k) * drho_air(k)
                 ENDDO
 
@@ -452,21 +477,41 @@
 !
 !--       Natural-type surfaces, upward-facing
-          surf_s = surf_lsm_h%start_index(j,i)
-          surf_e = surf_lsm_h%end_index(j,i)
-          DO  m = surf_s, surf_e
-
-             k   = surf_lsm_h%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_lsm_h%usws(m) ) ) * ddzw(k) * drho_air(k)
+          surf_s = surf_lsm_h(0)%start_index(j,i)
+          surf_e = surf_lsm_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_lsm_h(0)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_lsm_h(0)%usws(m) ) ) * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Natural-type surfaces, downward-facing
+          surf_s = surf_lsm_h(1)%start_index(j,i)
+          surf_e = surf_lsm_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_lsm_h(1)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - surf_lsm_h(1)%usws(m) ) * ddzw(k) * drho_air(k)
           ENDDO
 !
 !--       Urban-type surfaces, upward-facing
-          surf_s = surf_usm_h%start_index(j,i)
-          surf_e = surf_usm_h%end_index(j,i)
-          DO  m = surf_s, surf_e
-
-             k   = surf_usm_h%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_usm_h%usws(m) ) ) * ddzw(k) * drho_air(k)
+          surf_s = surf_usm_h(0)%start_index(j,i)
+          surf_e = surf_usm_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_usm_h(0)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_usm_h(0)%usws(m) ) ) * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Urban-type surfaces, downward-facing
+          surf_s = surf_usm_h(1)%start_index(j,i)
+          surf_e = surf_usm_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+
+             k   = surf_usm_h(1)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - surf_usm_h(1)%usws(m) ) * ddzw(k) * drho_air(k)
           ENDDO
 
Index: palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_v.f90	(revision 4670)
+++ palm/trunk/SOURCE/diffusion_v.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4583 2020-06-29 12:36:47Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -241,22 +244,44 @@
 !
 !--             Natural-type surfaces, upward-facing
-                surf_s = surf_lsm_h%start_index(j,i)
-                surf_e = surf_lsm_h%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_lsm_h%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_lsm_h%vsws(m) ) ) * ddzw(k) * drho_air(k)
+                surf_s = surf_lsm_h(0)%start_index(j,i)
+                surf_e = surf_lsm_h(0)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k   = surf_lsm_h(0)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - ( - surf_lsm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
+
+                ENDDO
+!
+!--             Natural-type surfaces, downward-facing
+                surf_s = surf_lsm_h(1)%start_index(j,i)
+                surf_e = surf_lsm_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k   = surf_lsm_h(1)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 +  ( - surf_lsm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
 
                 ENDDO
 !
 !--             Urban-type surfaces, upward-facing
-                surf_s = surf_usm_h%start_index(j,i)
-                surf_e = surf_usm_h%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k   = surf_usm_h%k(m)
-
-                   tend(k,j,i) = tend(k,j,i)                                                       &
-                                 + ( - ( - surf_usm_h%vsws(m) ) ) * ddzw(k) * drho_air(k)
+                surf_s = surf_usm_h(0)%start_index(j,i)
+                surf_e = surf_usm_h(0)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k   = surf_usm_h(0)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - ( - surf_usm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
+
+                ENDDO
+!
+!--             Urban-type surfaces, downward-facing
+                surf_s = surf_usm_h(1)%start_index(j,i)
+                surf_e = surf_usm_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k   = surf_usm_h(1)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                                       &
+                                 + ( - surf_usm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
 
                 ENDDO
@@ -446,20 +471,40 @@
 !
 !--       Natural-type surfaces, upward-facing
-          surf_s = surf_lsm_h%start_index(j,i)
-          surf_e = surf_lsm_h%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_lsm_h%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_lsm_h%vsws(m) ) ) * ddzw(k) * drho_air(k)
+          surf_s = surf_lsm_h(0)%start_index(j,i)
+          surf_e = surf_lsm_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_lsm_h(0)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_lsm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
+
+          ENDDO
+!
+!--       Natural-type surfaces, downward-facing
+          surf_s = surf_lsm_h(1)%start_index(j,i)
+          surf_e = surf_lsm_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_lsm_h(1)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - surf_lsm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
 
           ENDDO
 !
 !--       Urban-type surfaces, upward-facing
-          surf_s = surf_usm_h%start_index(j,i)
-          surf_e = surf_usm_h%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_usm_h%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_usm_h%vsws(m) ) ) * ddzw(k) * drho_air(k)
+          surf_s = surf_usm_h(0)%start_index(j,i)
+          surf_e = surf_usm_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_usm_h(0)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_usm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
+
+          ENDDO
+!
+!--       Urban-type surfaces, downward-facing
+          surf_s = surf_usm_h(1)%start_index(j,i)
+          surf_e = surf_usm_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_usm_h(1)%k(m)
+
+             tend(k,j,i) = tend(k,j,i) + ( - surf_usm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
 
           ENDDO
